/*
 * @(#) $Id: FunctionStatementInternalIterator.java 8610 2011-10-27 12:59:40Z laslovd $
 *
 * Copyright 2009/2010 by sIT Solutions,
 * A-1110 Wien, Geiselbergstr.21-25.
 * All rights reserved.
 *
 */
package org.openxma.dsl.generator.impl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.openxma.dsl.generator.helper.EventExtension;
import org.openxma.dsl.pom.model.Command;
import org.openxma.dsl.pom.model.CommandImplementation;
import org.openxma.dsl.pom.model.Statement;

import at.spardat.xma.guidesign.XMAPage;
import at.spardat.xma.guidesign.flex.XMAFunction;

public abstract class FunctionStatementInternalIterator {
    private XMAFunction function;
    private XMAPage page;
    
    public FunctionStatementInternalIterator ( XMAFunction function, XMAPage page ) {
        this.function = function;
        this.page = page;
    }

    public boolean iterate () {
        Command commandProperty = EventExtension.getCommandProperty(function);
        if ( commandProperty == null )
            return false;
        CommandImplementation implementation = commandProperty.getImplementation();
        if ( implementation != null ) {
            if (implementation.getStatements() != null && implementation.getStatements() != null) {
                EObjectContainmentEList<Statement> statements = (EObjectContainmentEList<Statement>) implementation.getStatements();
                for (Statement stmt : statements) {
                    if ( visit(stmt,page) )
                        return true;
                }
            }
        }
        return false;
    }
    
    /**
     * @return false to continue, true to stop grabbing
     */
    protected abstract boolean visit ( Statement stmt, XMAPage page );
}
